/**

   jZls
   
**/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dirent.h>

#define FN_BLKSIZE 8192
#define TERM_COLUMN  80

int main( int argc, char *argv[] )
{
DIR *dirp ;
struct dirent *dp ;
unsigned char *fn_buf ;
int fn_blk, fn_len, bpt ;
int max_len ;
int term_column, colm ;
unsigned char *spaces ;
int i ; 

 dirp=opendir( "." ) ;
 if( dirp==NULL ){
   printf("Permission denied.\n") ;
   exit(0) ;
 }
 fn_blk=1 ;
 fn_len=fn_blk*FN_BLKSIZE ;
 fn_buf=malloc( fn_len ) ;
 if( fn_buf==NULL ) {
   printf("memory exhausted.\n") ;
   exit(-1) ;
 }
 bpt=0 ;
 max_len=0 ;
 while( -1 ){
   int name_len ;

   dp=readdir(dirp) ;
   if( dp==NULL ) break ;
   name_len = strlen(dp->d_name) ;
   if( name_len>max_len ) max_len=name_len ;
   if( bpt + name_len > fn_len ){
     unsigned char *new_fn_len ;
     fn_blk++ ;
     fn_len=fn_blk*FN_BLKSIZE ;
     new_fn_len=realloc( fn_buf, fn_len ) ;
     if( new_fn_len==NULL ){
       printf("memory exhausted.\n") ;
       exit(-1) ;
     }
     fn_buf=new_fn_len ;
   }
   strcpy( &fn_buf[bpt], dp->d_name ) ;
   bpt+=(name_len+1) ;
 }
 fn_buf[bpt]='\0' ;
 
 term_column=TERM_COLUMN ;
 spaces = malloc( term_column + 1 ) ;
 for( i=0 ; i<term_column ; i++ ){
   spaces[i]=' ' ;
 }
 spaces[term_column]='\0' ;
 
 if( (max_len+2) > term_column ){
   colm=1 ;
 }else{
   colm=term_column/(max_len+2) ;
 }
 bpt=0 ; i=0 ;
 while( -1 ){
   int name_len ;

   if( fn_buf[bpt]=='\0' ) break ;
   name_len=strlen(&fn_buf[bpt]) ;
   printf("%s", &fn_buf[bpt] ) ;
   printf("%s", &spaces[term_column-(max_len+2)+name_len+1] ) ;
   bpt += name_len + 1 ;
   i++ ;
   if( i==colm ){
     printf("\n") ;
     i=0 ;
   }
 }
 printf("\n") ;
 exit(0) ;
}
     
